##// END OF EJS Templates
increased fs overhead from 25% to 35%...
drtyhlpr -
r242:0f89bb943f1b
parent child
Show More
@@ -1,657 +1,657
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 20+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
46 46 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
47 47 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
48 48 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
49 49
50 50 # Debian release
51 51 RELEASE=${RELEASE:=jessie}
52 52 KERNEL_ARCH=${KERNEL_ARCH:=arm}
53 53 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
54 54 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
55 55 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
56 56 if [ "$KERNEL_ARCH" = "arm64" ] ; then
57 57 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
58 58 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
59 59 else
60 60 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
61 61 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
62 62 fi
63 63 if [ "$RELEASE_ARCH" = "arm64" ] ; then
64 64 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
65 65 else
66 66 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
67 67 fi
68 68 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
69 69
70 70 # URLs
71 71 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
72 72 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
73 73 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
74 74 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
75 75 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
76 76 UBOOT_URL=${UBOOT_URL:=git://git.denx.de/u-boot.git}
77 77
78 78 # Build directories
79 79 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
80 80 BUILDDIR="${BASEDIR}/build"
81 81
82 82 # Prepare date string for default image file name
83 83 DATE="$(date +%Y-%m-%d)"
84 84 if [ -z "$KERNEL_BRANCH" ] ; then
85 85 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
86 86 else
87 87 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
88 88 fi
89 89
90 90 # Chroot directories
91 91 R="${BUILDDIR}/chroot"
92 92 ETC_DIR="${R}/etc"
93 93 LIB_DIR="${R}/lib"
94 94 BOOT_DIR="${R}/boot/firmware"
95 95 KERNEL_DIR="${R}/usr/src/linux"
96 96 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
97 97
98 98 # Firmware directory: Blank if download from github
99 99 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
100 100
101 101 # General settings
102 102 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
103 103 PASSWORD=${PASSWORD:=raspberry}
104 104 USER_PASSWORD=${USER_PASSWORD:=raspberry}
105 105 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
106 106 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
107 107 EXPANDROOT=${EXPANDROOT:=true}
108 108
109 109 # Keyboard settings
110 110 XKB_MODEL=${XKB_MODEL:=""}
111 111 XKB_LAYOUT=${XKB_LAYOUT:=""}
112 112 XKB_VARIANT=${XKB_VARIANT:=""}
113 113 XKB_OPTIONS=${XKB_OPTIONS:=""}
114 114
115 115 # Network settings (DHCP)
116 116 ENABLE_DHCP=${ENABLE_DHCP:=true}
117 117
118 118 # Network settings (static)
119 119 NET_ADDRESS=${NET_ADDRESS:=""}
120 120 NET_GATEWAY=${NET_GATEWAY:=""}
121 121 NET_DNS_1=${NET_DNS_1:=""}
122 122 NET_DNS_2=${NET_DNS_2:=""}
123 123 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
124 124 NET_NTP_1=${NET_NTP_1:=""}
125 125 NET_NTP_2=${NET_NTP_2:=""}
126 126
127 127 # APT settings
128 128 APT_PROXY=${APT_PROXY:=""}
129 129 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
130 130
131 131 # Feature settings
132 132 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
133 133 ENABLE_I2C=${ENABLE_I2C:=false}
134 134 ENABLE_SPI=${ENABLE_SPI:=false}
135 135 ENABLE_IPV6=${ENABLE_IPV6:=true}
136 136 ENABLE_SSHD=${ENABLE_SSHD:=true}
137 137 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
138 138 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
139 139 ENABLE_SOUND=${ENABLE_SOUND:=true}
140 140 ENABLE_DBUS=${ENABLE_DBUS:=true}
141 141 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
142 142 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
143 143 ENABLE_XORG=${ENABLE_XORG:=false}
144 144 ENABLE_WM=${ENABLE_WM:=""}
145 145 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
146 146 ENABLE_USER=${ENABLE_USER:=true}
147 147 USER_NAME=${USER_NAME:="pi"}
148 148 ENABLE_ROOT=${ENABLE_ROOT:=false}
149 149
150 150 # SSH settings
151 151 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
152 152 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
153 153 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
154 154 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
155 155 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
156 156
157 157 # Advanced settings
158 158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
159 159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
160 160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
161 161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
162 162 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
163 163 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
164 164 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
165 165 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
166 166 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
167 167 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
168 168 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
169 169 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
170 170
171 171 # Kernel compilation settings
172 172 BUILD_KERNEL=${BUILD_KERNEL:=false}
173 173 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
174 174 KERNEL_THREADS=${KERNEL_THREADS:=1}
175 175 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
176 176 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
177 177 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
178 178 if [ "$KERNEL_ARCH" = "arm64" ] ; then
179 179 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
180 180 else
181 181 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
182 182 fi
183 183
184 184 # Kernel compilation from source directory settings
185 185 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
186 186 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
187 187 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
188 188 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
189 189
190 190 # Reduce disk usage settings
191 191 REDUCE_APT=${REDUCE_APT:=true}
192 192 REDUCE_DOC=${REDUCE_DOC:=true}
193 193 REDUCE_MAN=${REDUCE_MAN:=true}
194 194 REDUCE_VIM=${REDUCE_VIM:=false}
195 195 REDUCE_BASH=${REDUCE_BASH:=false}
196 196 REDUCE_HWDB=${REDUCE_HWDB:=true}
197 197 REDUCE_SSHD=${REDUCE_SSHD:=true}
198 198 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
199 199
200 200 # Encrypted filesystem settings
201 201 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
202 202 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
203 203 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
204 204 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
205 205 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
206 206
207 207 # Stop the Crypto Wars
208 208 DISABLE_FBI=${DISABLE_FBI:=false}
209 209
210 210 # Chroot scripts directory
211 211 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
212 212
213 213 # Packages required in the chroot build environment
214 214 APT_INCLUDES=${APT_INCLUDES:=""}
215 215 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
216 216
217 217 # Packages required for bootstrapping
218 218 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
219 219 MISSING_PACKAGES=""
220 220
221 221 # Packages installed for c/c++ build environment in chroot (keep empty)
222 222 COMPILER_PACKAGES=""
223 223
224 224 set +x
225 225
226 226 # Set Raspberry Pi model specific configuration
227 227 if [ "$RPI_MODEL" = 2 ] ; then
228 228 DTB_FILE=${RPI2_DTB_FILE}
229 229 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
230 230 elif [ "$RPI_MODEL" = 3 ] ; then
231 231 DTB_FILE=${RPI3_DTB_FILE}
232 232 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
233 233 BUILD_KERNEL=true
234 234 else
235 235 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
236 236 exit 1
237 237 fi
238 238
239 239 # Check if the internal wireless interface is supported by the RPi model
240 240 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" != 3 ] ; then
241 241 echo "error: The selected Raspberry Pi model has no internal wireless interface"
242 242 exit 1
243 243 fi
244 244
245 245 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
246 246 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
247 247 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
248 248 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
249 249 exit 1
250 250 fi
251 251 fi
252 252
253 253 # Build RPi2/3 Linux kernel if required by Debian release
254 254 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
255 255 BUILD_KERNEL=true
256 256 fi
257 257
258 258 # Add packages required for kernel cross compilation
259 259 if [ "$BUILD_KERNEL" = true ] ; then
260 260 if [ "$KERNEL_ARCH" = "arm" ] ; then
261 261 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
262 262 else
263 263 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
264 264 fi
265 265 fi
266 266
267 267 # Add libncurses5 to enable kernel menuconfig
268 268 if [ "$KERNEL_MENUCONFIG" = true ] ; then
269 269 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
270 270 fi
271 271
272 272 # Stop the Crypto Wars
273 273 if [ "$DISABLE_FBI" = true ] ; then
274 274 ENABLE_CRYPTFS=true
275 275 fi
276 276
277 277 # Add cryptsetup package to enable filesystem encryption
278 278 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
279 279 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
280 280 APT_INCLUDES="${APT_INCLUDES},cryptsetup"
281 281
282 282 if [ -z "$CRYPTFS_PASSWORD" ] ; then
283 283 echo "error: no password defined (CRYPTFS_PASSWORD)!"
284 284 exit 1
285 285 fi
286 286 ENABLE_INITRAMFS=true
287 287 fi
288 288
289 289 # Add initramfs generation tools
290 290 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
291 291 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
292 292 fi
293 293
294 294 # Add device-tree-compiler required for building the U-Boot bootloader
295 295 if [ "$ENABLE_UBOOT" = true ] ; then
296 296 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
297 297 fi
298 298
299 299 # Check if root SSH (v2) public key file exists
300 300 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
301 301 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
302 302 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
303 303 exit 1
304 304 fi
305 305 fi
306 306
307 307 # Check if $USER_NAME SSH (v2) public key file exists
308 308 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
309 309 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
310 310 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
311 311 exit 1
312 312 fi
313 313 fi
314 314
315 315 # Check if all required packages are installed on the build system
316 316 for package in $REQUIRED_PACKAGES ; do
317 317 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
318 318 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
319 319 fi
320 320 done
321 321
322 322 # If there are missing packages ask confirmation for install, or exit
323 323 if [ -n "$MISSING_PACKAGES" ] ; then
324 324 echo "the following packages needed by this script are not installed:"
325 325 echo "$MISSING_PACKAGES"
326 326
327 327 echo -n "\ndo you want to install the missing packages right now? [y/n] "
328 328 read confirm
329 329 [ "$confirm" != "y" ] && exit 1
330 330
331 331 # Make sure all missing required packages are installed
332 332 apt-get -qq -y install ${MISSING_PACKAGES}
333 333 fi
334 334
335 335 # Check if ./bootstrap.d directory exists
336 336 if [ ! -d "./bootstrap.d/" ] ; then
337 337 echo "error: './bootstrap.d' required directory not found!"
338 338 exit 1
339 339 fi
340 340
341 341 # Check if ./files directory exists
342 342 if [ ! -d "./files/" ] ; then
343 343 echo "error: './files' required directory not found!"
344 344 exit 1
345 345 fi
346 346
347 347 # Check if specified KERNELSRC_DIR directory exists
348 348 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
349 349 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
350 350 exit 1
351 351 fi
352 352
353 353 # Check if specified UBOOTSRC_DIR directory exists
354 354 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
355 355 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
356 356 exit 1
357 357 fi
358 358
359 359 # Check if specified FBTURBOSRC_DIR directory exists
360 360 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
361 361 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
362 362 exit 1
363 363 fi
364 364
365 365 # Check if specified CHROOT_SCRIPTS directory exists
366 366 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
367 367 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
368 368 exit 1
369 369 fi
370 370
371 371 # Check if specified device mapping already exists (will be used by cryptsetup)
372 372 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
373 373 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
374 374 exit 1
375 375 fi
376 376
377 377 # Don't clobber an old build
378 378 if [ -e "$BUILDDIR" ] ; then
379 379 echo "error: directory ${BUILDDIR} already exists, not proceeding"
380 380 exit 1
381 381 fi
382 382
383 383 # Setup chroot directory
384 384 mkdir -p "${R}"
385 385
386 386 # Check if build directory has enough of free disk space >512MB
387 387 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
388 388 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
389 389 exit 1
390 390 fi
391 391
392 392 set -x
393 393
394 394 # Call "cleanup" function on various signals and errors
395 395 trap cleanup 0 1 2 3 6
396 396
397 397 # Add required packages for the minbase installation
398 398 if [ "$ENABLE_MINBASE" = true ] ; then
399 399 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
400 400 fi
401 401
402 402 # Add required locales packages
403 403 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
404 404 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
405 405 fi
406 406
407 407 # Add parted package, required to get partprobe utility
408 408 if [ "$EXPANDROOT" = true ] ; then
409 409 APT_INCLUDES="${APT_INCLUDES},parted"
410 410 fi
411 411
412 412 # Add dbus package, recommended if using systemd
413 413 if [ "$ENABLE_DBUS" = true ] ; then
414 414 APT_INCLUDES="${APT_INCLUDES},dbus"
415 415 fi
416 416
417 417 # Add iptables IPv4/IPv6 package
418 418 if [ "$ENABLE_IPTABLES" = true ] ; then
419 419 APT_INCLUDES="${APT_INCLUDES},iptables"
420 420 fi
421 421
422 422 # Add openssh server package
423 423 if [ "$ENABLE_SSHD" = true ] ; then
424 424 APT_INCLUDES="${APT_INCLUDES},openssh-server"
425 425 fi
426 426
427 427 # Add alsa-utils package
428 428 if [ "$ENABLE_SOUND" = true ] ; then
429 429 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
430 430 fi
431 431
432 432 # Add rng-tools package
433 433 if [ "$ENABLE_HWRANDOM" = true ] ; then
434 434 APT_INCLUDES="${APT_INCLUDES},rng-tools"
435 435 fi
436 436
437 437 # Add fbturbo video driver
438 438 if [ "$ENABLE_FBTURBO" = true ] ; then
439 439 # Enable xorg package dependencies
440 440 ENABLE_XORG=true
441 441 fi
442 442
443 443 # Add user defined window manager package
444 444 if [ -n "$ENABLE_WM" ] ; then
445 445 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
446 446
447 447 # Enable xorg package dependencies
448 448 ENABLE_XORG=true
449 449 fi
450 450
451 451 # Add xorg package
452 452 if [ "$ENABLE_XORG" = true ] ; then
453 453 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
454 454 fi
455 455
456 456 # Replace selected packages with smaller clones
457 457 if [ "$ENABLE_REDUCE" = true ] ; then
458 458 # Add levee package instead of vim-tiny
459 459 if [ "$REDUCE_VIM" = true ] ; then
460 460 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
461 461 fi
462 462
463 463 # Add dropbear package instead of openssh-server
464 464 if [ "$REDUCE_SSHD" = true ] ; then
465 465 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
466 466 fi
467 467 fi
468 468
469 469 if [ "$RELEASE" != "jessie" ] ; then
470 470 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
471 471 fi
472 472
473 473 # Configure kernel sources if no KERNELSRC_DIR
474 474 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
475 475 KERNELSRC_CONFIG=true
476 476 fi
477 477
478 478 # Configure reduced kernel
479 479 if [ "$KERNEL_REDUCE" = true ] ; then
480 480 KERNELSRC_CONFIG=false
481 481 fi
482 482
483 483 # Execute bootstrap scripts
484 484 for SCRIPT in bootstrap.d/*.sh; do
485 485 head -n 3 "$SCRIPT"
486 486 . "$SCRIPT"
487 487 done
488 488
489 489 ## Execute custom bootstrap scripts
490 490 if [ -d "custom.d" ] ; then
491 491 for SCRIPT in custom.d/*.sh; do
492 492 . "$SCRIPT"
493 493 done
494 494 fi
495 495
496 496 # Execute custom scripts inside the chroot
497 497 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
498 498 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
499 499 chroot_exec /bin/bash -x <<'EOF'
500 500 for SCRIPT in /chroot_scripts/* ; do
501 501 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
502 502 $SCRIPT
503 503 fi
504 504 done
505 505 EOF
506 506 rm -rf "${R}/chroot_scripts"
507 507 fi
508 508
509 509 # Remove c/c++ build environment from the chroot
510 510 chroot_remove_cc
511 511
512 512 # Remove apt-utils
513 513 if [ "$RELEASE" = "jessie" ] ; then
514 514 chroot_exec apt-get purge -qq -y --force-yes apt-utils
515 515 fi
516 516
517 517 # Generate required machine-id
518 518 MACHINE_ID=$(dbus-uuidgen)
519 519 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
520 520 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
521 521
522 522 # APT Cleanup
523 523 chroot_exec apt-get -y clean
524 524 chroot_exec apt-get -y autoclean
525 525 chroot_exec apt-get -y autoremove
526 526
527 527 # Unmount mounted filesystems
528 528 umount -l "${R}/proc"
529 529 umount -l "${R}/sys"
530 530
531 531 # Clean up directories
532 532 rm -rf "${R}/run/*"
533 533 rm -rf "${R}/tmp/*"
534 534
535 535 # Clean up files
536 536 rm -f "${ETC_DIR}/ssh/ssh_host_*"
537 537 rm -f "${ETC_DIR}/dropbear/dropbear_*"
538 538 rm -f "${ETC_DIR}/apt/sources.list.save"
539 539 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
540 540 rm -f "${ETC_DIR}/*-"
541 541 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
542 542 rm -f "${ETC_DIR}/resolv.conf"
543 543 rm -f "${R}/root/.bash_history"
544 544 rm -f "${R}/var/lib/urandom/random-seed"
545 545 rm -f "${R}/initrd.img"
546 546 rm -f "${R}/vmlinuz"
547 547 rm -f "${R}${QEMU_BINARY}"
548 548
549 549 # Calculate size of the chroot directory in KB
550 550 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
551 551
552 552 # Calculate the amount of needed 512 Byte sectors
553 553 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
554 554 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
555 555 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
556 556
557 557 # The root partition is EXT4
558 558 # This means more space than the actual used space of the chroot is used.
559 # As overhead for journaling and reserved blocks 25% are added.
560 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 25) \* 1024 \/ 512)
559 # As overhead for journaling and reserved blocks 35% are added.
560 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
561 561
562 562 # Calculate required image size in 512 Byte sectors
563 563 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
564 564
565 565 # Prepare image file
566 566 if [ "$ENABLE_SPLITFS" = true ] ; then
567 567 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
568 568 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
569 569 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
570 570 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
571 571
572 572 # Write firmware/boot partition tables
573 573 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
574 574 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
575 575 EOM
576 576
577 577 # Write root partition table
578 578 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
579 579 ${TABLE_SECTORS},${ROOT_SECTORS},83
580 580 EOM
581 581
582 582 # Setup temporary loop devices
583 583 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
584 584 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
585 585 else # ENABLE_SPLITFS=false
586 586 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
587 587 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
588 588
589 589 # Write partition table
590 590 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
591 591 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
592 592 ${ROOT_OFFSET},${ROOT_SECTORS},83
593 593 EOM
594 594
595 595 # Setup temporary loop devices
596 596 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
597 597 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
598 598 fi
599 599
600 600 if [ "$ENABLE_CRYPTFS" = true ] ; then
601 601 # Create dummy ext4 fs
602 602 mkfs.ext4 "$ROOT_LOOP"
603 603
604 604 # Setup password keyfile
605 605 touch .password
606 606 chmod 600 .password
607 607 echo -n ${CRYPTFS_PASSWORD} > .password
608 608
609 609 # Initialize encrypted partition
610 610 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
611 611
612 612 # Open encrypted partition and setup mapping
613 613 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
614 614
615 615 # Secure delete password keyfile
616 616 shred -zu .password
617 617
618 618 # Update temporary loop device
619 619 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
620 620
621 621 # Wipe encrypted partition (encryption cipher is used for randomness)
622 622 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
623 623 fi
624 624
625 625 # Build filesystems
626 626 mkfs.vfat "$FRMW_LOOP"
627 627 mkfs.ext4 "$ROOT_LOOP"
628 628
629 629 # Mount the temporary loop devices
630 630 mkdir -p "$BUILDDIR/mount"
631 631 mount "$ROOT_LOOP" "$BUILDDIR/mount"
632 632
633 633 mkdir -p "$BUILDDIR/mount/boot/firmware"
634 634 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
635 635
636 636 # Copy all files from the chroot to the loop device mount point directory
637 637 rsync -a "${R}/" "$BUILDDIR/mount/"
638 638
639 639 # Unmount all temporary loop devices and mount points
640 640 cleanup
641 641
642 642 # Create block map file(s) of image(s)
643 643 if [ "$ENABLE_SPLITFS" = true ] ; then
644 644 # Create block map files for "bmaptool"
645 645 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
646 646 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
647 647
648 648 # Image was successfully created
649 649 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
650 650 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
651 651 else
652 652 # Create block map file for "bmaptool"
653 653 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
654 654
655 655 # Image was successfully created
656 656 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
657 657 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant